



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Javascript高级编程学习笔记（2）—— Script标签</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Javascript高级编程学习笔记（2）—— Script标签</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 12:52:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>script标签</h2>
<p>js在浏览器中的使用，肯定会涉及到script标签。</p>
<p>那么script标签有哪些属性呢？</p>
<p>1.async：异步加载（不让页面等待该脚本的加载执行，异步加载页面的其他部分）</p>
<p>2.charset：设置js的字符集编码</p>
<p>3.defer：延迟脚本（当浏览器解析到/html&nbsp;结束标签时才执行，该属性对嵌入脚本无效）</p>
<p>4.language：代码所使用的脚本语言（已废弃）</p>
<p>5.src：要执行的外部代码文件</p>
<p>6.type：与language类似可以看作是language的替代属性</p>
<p>在上面的这些属性中src就不用过多的说明了，除了src使用较多，并且应用范围较广的就是async和defer了</p>
<p>下面将主要分析一下这两个属性</p>
<h3>首先是defer</h3>
<p>根据说明，设置了该属性的script外部文件会在解析到&lt;/html&gt;标签的时候才开始执行，并且会在DOMcontentonload&nbsp;之前触发</p>
<p>而且根据html5的要求这些延迟脚本会按照在文档中的顺序执行</p>
<p>DOM文档加载步骤：</p>
<p>（1）解析html结构</p>
<p>（2）加载外部脚本和样式表文件</p>
<p>（3）解析并执行脚本代码</p>
<p>（4）构造HTML DOM模型&nbsp; &nbsp;//DOMContentLoaded执行点</p>
<p>（5）加载图片等外部文件</p>
<p>（6）页面加载完毕&nbsp; //load</p>
<p>我们来测试一下</p>
<p>首先新建一个简单的html页面</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html lang="zh"&gt;<br />
&lt;head&gt;<br />
  &lt;title&gt;title&lt;/title&gt;<br />
  &lt;meta charset="utf-8"/&gt;<br />
  &lt;meta name="Description" content=""/&gt;<br />
  &lt;meta name="Author" content="巽秋"/&gt;<br />
  &lt;style type="text/css"&gt;&lt;/style&gt;<br />
  &lt;script src="./1.js"&gt;&lt;/script&gt;<br />
  &lt;script src="./2.js"&gt;&lt;/script&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;

&lt;script&gt;<br />
  window.addEventListener("DOMContentLoaded", function () {  //添加DOMContentLoaded事件<br />
    console.log("domContentLoad执行");<br />
  }, false);<br />
  console.log("这里是嵌入脚本");<br />
&lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>引入的外部js文件代码如下：</p>
<div>
<pre class="prettyprint linenums">console.log("这里是外部脚本1");//1.js 中的内容</pre>
</div>
<div>
<pre class="prettyprint linenums">console.log("这里是外部脚本2");//2.js 中的内容</pre>
</div>
<p>我们打开该页面结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927085952725-872589343.png" /></p>
<p>我们可以看到DOMContentLoaded是在js代码执行完后执行的</p>
<p>现在我们再给外部引入的两个js文件加上defer属性</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927090236624-311363937.png" /></p>
<p>再次运行查看结果</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927090319673-925616008.png" /></p>
<p>我们可以看到嵌入脚本比1.js和2.js先执行了并且在domcontentloaded事件触发之前就执行完毕了</p>
<p>和我们预先预测的结果一致。</p>
<p>接下来我们再看一下，这两个外部文件的执行顺序是否真的和在页面中出现的顺序一致</p>
<p>我们交换一下两个script标签的引入的位置</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927090722452-947132585.png" /></p>
<p>再看一下结果</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927090750515-1729104124.png" /></p>
<p>说明defer的延迟脚本的加载顺序和该脚本在页面中出现的顺序是一致的</p>
<p>说明的确是这样的</p>
<p>不过书中说实际上有可能不一定是这样的，所以我又换了几个浏览器试试</p>
<p>刚才的是chrome浏览器的结果</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927091110065-828438427.png" /></p>
<p>这是火狐浏览器的结果</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927091333364-1023381699.png" /></p>
<p>这是ie11</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927091410909-701135589.png" /></p>
<p>ie10</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927091522454-237787684.png" /></p>
<p>虽然在低版本ie中addEventlistenter有兼容问题但是我们可以看到defer脚本的加载顺序并没有什么改变</p>
<p>所以我也不知道在什么情况下延迟脚本会不遵守这个规则</p>
<h3>然后是async</h3>
<p>书中给出的描述是有该属性的脚本，立即加载并执行，页面的其他部分异步加载</p>
<p>并且async属性的标签一定会在window.onload之前执行，可能会在domcontentloaded之后执行</p>
<p>该属性的脚本不会按顺序到来，所以在使用时需要确保该属性的脚本之间没有依赖关系</p>
<p>首先给之前引入的两个标签的defer改为async属性</p>
<p>然后加上window.onload事件</p>
<p>再来看一下结果</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html lang="zh"&gt;<br />
&lt;head&gt;<br />
  &lt;title&gt;title&lt;/title&gt;<br />
  &lt;meta charset="utf-8"/&gt;<br />
  &lt;meta name="Description" content=""/&gt;<br />
  &lt;meta name="Author" content="巽秋"/&gt;<br />
  &lt;style type="text/css"&gt;&lt;/style&gt;<br />
  &lt;script src="./2.js" async&gt;&lt;/script&gt;<br />
  &lt;script src="./1.js"async&gt;&lt;/script&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;

&lt;script&gt;<br />
  window.addEventListener("DOMContentLoaded", function () {  //添加DOMContentLoaded事件<br />
    console.log("domContentLoad执行");<br />
  }, false);<br />
  window.onload = function(){<br />
    console.log("window.onload执行");<br />
  };<br />
  console.log("这里是嵌入脚本");<br />
&lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>结果如下</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927092712177-1059621285.png" /></p>
<p>这里由于页面异步加载所以</p>
<p>嵌入脚本先执行了</p>
<p>异步脚本在domcontentloaded之后执行的</p>
<p>我为了测试不按顺序到来</p>
<p>我给两个js的consle之前加了循环</p>
<p>来控制加载的时间</p>
<p>看看异步脚本是谁先加载完就先执行吗？</p>
<p>我在2.js的后面粘贴了jq1.12.4的代码</p>
<p>让2.js比1.js文件要大&nbsp;但是console都是第一句代码</p>
<p>2.js还会先console吗？</p>
<p>我们再来看看结果</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927093634631-1054301456.png" /></p>
<p>结果很显然</p>
<p>async&nbsp;属性的脚本应该是谁先加载完谁就先执行，并且不管怎样一定会在window.onload事件之前执行</p>
<h2>noscript标签</h2>
<p>当浏览器没有js环境，或者js被关闭的时候我们往往需要给用户一些提示之类的</p>
<p>那么这就是noscript标签的作用</p>
<p>我们再建一个新的html页面</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html lang="zh"&gt;<br />
&lt;head&gt;<br />
  &lt;title&gt;title&lt;/title&gt;<br />
  &lt;meta charset="utf-8"/&gt;<br />
  &lt;meta name="Description" content=""/&gt;<br />
  &lt;meta name="Author" content="巽秋"/&gt;<br />
  &lt;style type="text/css"&gt;&lt;/style&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;

  &lt;noscript&gt;您的浏览器未开启js&lt;/noscript&gt;<br />
&lt;script&gt;<br />
  console.log("js");<br />
&lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>我们打开这个页面</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927094826117-3293975.png" /></p>
<p>我们可以看到在js开启的情况下noscript标签中的内容是不会显示的</p>
<p>我接下来关闭js</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927095105996-1286146761.png" /></p>
<p>然后刷新页面</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467672/201809/1467672-20180927095301636-1249448807.png" /></p>
<p>今天就记录一下script标签吧</p>
<p>写完，收工。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495zyde9.html">Python list嵌套 三维数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1wny09.html">【转】Android世界的Swift - Kotlin语言</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2e623q.html">hdu 1030  Delta-wave</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zvmd59.html">NOIP2003 加分二叉树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdnmd38.html">cxgrid  HyperLink 鼠标显示效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zpzdn9.html">jQuery插件slides实现无缝轮播图特效</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv10yeoq.html">【Egret】2D 使用中的一些疑难解决技巧！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1jg0yq.html">理解js中的运算符优先级</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzrrde8.html">自用公共js文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnje7g38.html">Mysql大量插入数据时SQL语句的优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdoyvk9.html">Python中urllib&period;urlencode中文字符的一个问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzo7y48.html">3&period; VIM 系列 - 遇见你的第一个插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4e3pz9.html">shift and算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rn0z58.html">cf776c</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j5xxnq.html">vs问题集</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2gl219.html">webpack中配置Babel</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko12wrq.html">iOS手势UIGestureRecognizer的使用及手势冲突的解决办法【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qved47y9.html">JS中生成和解析JSON</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnyg7gq.html">webserive学习记录1-jdk自带webservice</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjy1dp8.html">DIV&plus;CSS&colon;如何编写代码才能更有效率</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/960z3ov9.html">HTML DOM学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5k4jmq.html">DJango 基础（7）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1l5jlq.html">Android  二维码扫描&sol;生成</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1dpe09.html">HDU6446 Tree and Permutation（树上DP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2rp16q.html">FortiGate 5&period;2&sol;5&period;4 SSLVPN建立</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw2gok8.html">微信公众号的分享接口，分享提示config&colon;fail&comma;invalid signature的解决办法（2017年12月）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wg720q.html">centos关机与重启命令 shutdown -r now 立刻重启</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2rykoq.html">万能的一句话 json</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv23jjj9.html">java【基础】日期操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1dv6l9.html">Django之URL&lpar;路由系统&rpar;用法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
